<template>
  <basic-container>
    <avue-crud
      :option="option"
      :table-loading="loading"
      :data="data"
      :page.sync="page"
      :permission="permissionList"
      :before-open="beforeOpen"
      v-model="form"
      ref="crud"
      @row-update="rowUpdate"
      @row-save="rowSave"
      @row-del="rowDel"
      @search-change="searchChange"
      @search-reset="searchReset"
      @selection-change="selectionChange"
      @current-change="currentChange"
      @size-change="sizeChange"
      @refresh-change="refreshChange"
      @on-load="onLoad"
    >
      <template slot="menuLeft">
        <el-button
          type="danger"
          size="small"
          icon="el-icon-delete"
          plain
          v-if="permission.wbsinfo_delete"
          @click="handleDelete"
        >删 除
        </el-button>
      </template>
      <template slot="menuRight">
        <!-- 新增元素按钮 -->
        <el-button
          size="small"
          style="background-color:#FFA042;color:white;font-weight:bold"
          plain
          v-if="permission.wbsinfo_delete"
          @click="handleElement"
        >元素库
        </el-button>
      </template>
      <template
        slot-scope="{row,index}"
        slot="menu"
      >
        <el-button
          type="text"
          icon="el-icon-edit"
          size="mini"
          v-if="permission.wbsinfo_tree_edit"
          @click="toEdit(row,index)"
        >编辑wbs库</el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import { getList, getDetail, add, update, remove } from "@/api/manager/wbsinfo";
import { mapGetters } from "vuex";

export default {
  data () {
    return {
      form: {},
      query: {},
      loading: true,
      page: {
        pageSize: 20,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        menuWidth: 300,
        height: 'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        viewBtn: true,
        selection: true,
        dialogClickModal: false,
        column: [
          {
            label: "创建时间",
            prop: "createTime",
            editDetail: true,
            addDisabled: true,
          },
          {
            label: "wbs名称",
            prop: "wbsName",
            rules: [{
              required: true,
              message: "请输入wbs名称",
              trigger: "blur"
            }]
          },
          {
            label: "划分类型",
            type: "select",
            dicUrl: "/api/blade-system/dict/dictionary?code=wbs_type",
            props: {
              label: "dictValue",
              value: "dictKey"
            },
            dataType: "number",
            prop: "wbsType",
            rules: [{
              required: true,
              message: "请选择划分类型",
              trigger: "blur"
            }]
          },
          {
            label: "是否启用",
            prop: "status",
            rules: [{
              required: true,
              message: "是否启用",
              trigger: "blur"
            }],
            type: "radio",
            dicData: [
              {
                label: "否",
                value: 0
              },
              {
                label: "是",
                value: 1
              }
            ],
          },
        ]
      },
      data: [],
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList () {
      return {
        addBtn: this.vaildData(this.permission.wbsinfo_add, false),
        viewBtn: this.vaildData(this.permission.wbsinfo_view, false),
        delBtn: this.vaildData(this.permission.wbsinfo_delete, false),
        editBtn: this.vaildData(this.permission.wbsinfo_edit, false)
      };
    },
    ids () {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    //点击元素库
    handleElement(){
      console.log('元素库');
      this.$router.push({
        path: '/wbs/element',
      })
    },
    rowSave (row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        window.console.log(error);
      });
    },
    rowUpdate (row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        console.log(error);
      });
    },
    rowDel (row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    handleDelete () {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.$refs.crud.toggleSelection();
        });
    },
    beforeOpen (done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset () {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange (params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange (list) {
      this.selectionList = list;
    },
    selectionClear () {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange (currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange (pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange () {
      this.onLoad(this.page, this.query);
    },
    onLoad (page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    },

    toEdit (row) {
      console.log(row);
      this.$router.push({
        path: '/wbs/edit',
        query: {
          id: row.id,
          type: row.wbsType
        }
      })
      //this.$router.push('/wbs/edit/' + row.id);
    }
  }
};
</script>

<style>
</style>
